VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsFindandReplace"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private WithEvents Messages As clsSubClass
Attribute Messages.VB_VarHelpID = -1

'events
Public Event FoundNext(ByVal didFind As Boolean, ByVal strFindWhat As String, ByVal lStart As Long, Cancel As Boolean)
Public Event Terminated()
Public Event BeforeReplace(ByVal strFindWhat As String, ByVal strReplaceWith As String, ByVal lStart As Long, Cancel As Boolean)
Public Event BeforeReplaceAll(ByVal strFindWhat As String, ByVal strReplaceWith As String, Cancel As Boolean)
Public Event ShowHelp()

Private gTxtSrc As String

Private Type FINDREPLACE
   lStructSize As Long        '// size of this struct 0x20
   hWndOwner As Long          '// handle to owner's window
   hInstance As Long          '// instance handle of.EXE that
                              '//   contains cust. dlg. template
   flags As Long            '// one or more of the FR_??
   lpstrFindWhat As Long      '// ptr. to search string
   lpstrReplaceWith As Long '// ptr. to replace string
   wFindWhatLen As Integer        '// size of find buffer
   wReplaceWithLen As Integer '// size of replace buffer
   lCustData As Long          '// data passed to hook fn.
   lpfnHook As Long           '// ptr. to hook fn. or NULL
   lpTemplateName As Long   '// custom template name
End Type

Private Declare Function FindText Lib "comdlg32.dll" Alias "FindTextA" (pFindreplace As FINDREPLACE) As Long
Private Declare Function ReplaceText Lib "comdlg32.dll" Alias "ReplaceTextA" (pFindreplace As FINDREPLACE) As Long

Public Enum EFindReplaceFlags
    FR_DOWN = &H1&
    FR_WHOLEWORD = &H2&
    FR_MATCHCASE = &H4&
    FR_ENABLEHOOK = &H100&
    FR_ENABLETEMPLATE = &H200&
    FR_NOUPDOWN = &H400&
    FR_NOMATCHCASE = &H800&
    FR_NOWHOLEWORD = &H1000&
    FR_ENABLETEMPLATEHANDLE = &H2000&
    FR_HIDEUPDOWN = &H4000&
    FR_HIDEMATCHCASE = &H8000&
    FR_HIDEWHOLEWORD = &H10000
End Enum
Private Enum EFindReplaceNotificationFlags
    FR_REPLACEALL = &H20&
    FR_DIALOGTERM = &H40&
    FR_SHOWHELP = &H80&
    FR_FINDNEXT = &H8&
    FR_REPLACE = &H10&
End Enum
Private Declare Function GetVersion Lib "kernel32" () As Long

Private m_iFindReplaceMsg As Long  '// message identifier for FINDMSGSTRING
Private Const FINDMSGSTRING = "commdlg_FindReplace"
Private Declare Function RegisterWindowMessage Lib "user32" Alias _
 "RegisterWindowMessageA" (ByVal lpString As String) As Long
Private Declare Function LocalAlloc Lib "kernel32" (ByVal wFlags As Long, _
ByVal wBytes As Long) As Long
Private Declare Function LocalFree Lib "kernel32" (ByVal hMem As Long) As Long
Private Declare Function LocalLock Lib "kernel32" (ByVal hMem As Long) As Long
Private Declare Function LocalUnlock Lib "kernel32" (ByVal hMem As Long) As Long
Private Const GMEM_FIXED = &H0
Private Const GMEM_ZEROINIT = &H40
Private Const GPTR = (GMEM_FIXED Or GMEM_ZEROINIT)
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" ( _
    lpvDest As Any, lpvSource As Any, ByVal cbCopy As Long)
Private Declare Function CloseWindow Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function SendMessageLong Lib "user32" Alias "SendMessageA" _
 (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Const WM_SYSCOMMAND = &H112
Private Const SC_RESTORE = &HF120
Private Const SC_CLOSE = &HF060&

Private Const EM_SETSEL = &HB1
Private Const EM_GETSEL = &HB0
Private Const EM_REPLACESEL = &HC2

Private Const WM_GETTEXT = &HD
Private Const WM_GETTEXTLENGTH = &HE
Private Const WM_SETTEXT = &HC
Private Const WM_CLOSE = &H10
Private Const WM_DESTROY = &H2

'local variable(s) to hold property value(s)
Private mvarMatchCase As Long
Private mvarUpDown As Long
Private mvarWholeWord As Long
Private mvarShowHelp As Long

Enum frSHOWHELP
    dlgSHOWHELP = FR_SHOWHELP
    dlgNOHELP = 0&
End Enum

Enum frMATCHCASE
    dlgENABLEMATCHCASE = 0&
    dlgDISABLEMATCHCASE = FR_NOMATCHCASE
    dlgHIDEMATCHCASE = FR_HIDEMATCHCASE
    dlgSELECTMATCHCASE = FR_MATCHCASE
    dlgDESELECTMATCHCASE = 0&
End Enum

Enum frUPDOWN
    dlgENABLEUPDOWN = 0&
    dlgDISABLEUPDOWN = FR_NOUPDOWN
    dlgHIDEUPDOWN = FR_HIDEUPDOWN
    dlgSELECTDOWN = FR_DOWN
    dlgSELECTUP = 0&
End Enum

Enum frWHOLEWORD
    dlgENABLEWHOLEWORD = 0&
    dlgNOWHOLEWORD = FR_NOWHOLEWORD
    dlgHIDEWHOLEWORD = FR_HIDEWHOLEWORD
    dlgSELECTWHOLEWORD = FR_WHOLEWORD
    dlgDESELECTWHOLEWORD = 0&
End Enum


Private m_tF As FINDREPLACE
Private m_hWndFindText As Long
Private m_hwndTxt As Long
Private m_lBuffLen As Long
Private m_hFindBuffMem As Long
Private m_lptrFindBuff As Long
Private m_hReplaceBuffMem As Long
Private m_lptrReplaceBuff As Long

'Private m_hWndOwner As Long
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function SendMessageStr Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As String) As Long
Private Declare Function SetFocus Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function lstrcpyToPtr Lib "kernel32" Alias "lstrcpyA" (ByVal lpString1 As Long, ByVal lpString2 As String) As Long
Private Declare Function lstrcpyFromPtr Lib "kernel32" Alias "lstrcpyA" (ByVal lpString1 As String, ByVal lpString2 As Long) As Long
Private Declare Function lstrlen Lib "kernel32" Alias "lstrlenA" (ByVal lpString As Long) As Long

Public Function ShowFind(hWndTxt As Long) As Boolean
Dim sFindWhat As String
   
   If Not (m_hWndFindText = 0) Then
      SendMessageLong m_hWndFindText, WM_SYSCOMMAND, SC_CLOSE, 0
   End If

'    m_hWndOwner = hWndOwner
    m_hwndTxt = hWndTxt
    gTxtSrc = GetTextfromBox
    If gTxtSrc = "" Then Exit Function
    
    'put selected text into Find What box
    sFindWhat = GetSelected(gTxtSrc)
  
   m_tF.hWndOwner = m_hwndTxt
   m_tF.lCustData = m_hwndTxt
   m_tF.hInstance = 0
   m_tF.flags = mvarMatchCase Or mvarUpDown Or mvarWholeWord Or mvarShowHelp
   lstrcpyToPtr m_tF.lpstrFindWhat, sFindWhat
   m_hWndFindText = FindText(m_tF)
   
   If Not (m_hWndFindText = 0) Then
      Messages.Enable m_hwndTxt
      ShowFind = True
      SetFocus hWndTxt
   End If
    
End Function

Public Function ShowReplace(ByVal hWndTxt As Long) As Boolean
Dim sFindWhat As String
Dim sReplaceWith As String

   If Not (m_hWndFindText = 0) Then
      SendMessageLong m_hWndFindText, WM_SYSCOMMAND, SC_CLOSE, 0
   End If
      
   m_hwndTxt = hWndTxt
   gTxtSrc = GetTextfromBox
   If gTxtSrc = "" Then Exit Function

   'get selected text
   sFindWhat = GetSelected(gTxtSrc)

   m_tF.hWndOwner = m_hwndTxt
   m_tF.lCustData = m_hwndTxt
   m_tF.hInstance = 0
   m_tF.flags = mvarMatchCase Or FR_DOWN Or mvarWholeWord Or mvarShowHelp
   lstrcpyToPtr m_tF.lpstrFindWhat, sFindWhat
   lstrcpyToPtr m_tF.lpstrReplaceWith, sReplaceWith
   m_hWndFindText = ReplaceText(m_tF)
   
   If Not (m_hWndFindText = 0) Then
      Messages.Enable m_hwndTxt
      ShowReplace = True
      SetFocus hWndTxt
   End If
   
End Function

Public Property Get hWndDialog() As Long
   hWndDialog = m_hWndFindText
End Property

Private Sub Class_Initialize()
    
   Set Messages = New clsSubClass
   
   m_tF.lStructSize = Len(m_tF)
   
   m_lBuffLen = 1024
   
   m_hFindBuffMem = LocalAlloc(GPTR, m_lBuffLen)
   m_lptrFindBuff = LocalLock(m_hFindBuffMem)
   m_tF.lpstrFindWhat = m_lptrFindBuff
   m_tF.wFindWhatLen = m_lBuffLen
   
   m_hReplaceBuffMem = LocalAlloc(GPTR, m_lBuffLen)
   m_lptrReplaceBuff = LocalLock(m_hReplaceBuffMem)
   m_tF.lpstrReplaceWith = m_lptrReplaceBuff
   m_tF.wReplaceWithLen = m_lBuffLen
         
   m_iFindReplaceMsg = RegisterWindowMessage(FINDMSGSTRING)

    mvarUpDown = FR_DOWN

End Sub

Private Sub Class_Terminate()
   If Not (m_hwndTxt = 0) Then
        Messages.Unsubclass
   End If
   If Not (m_hWndFindText = 0) Then
      ' Want to close the dialog:
      SendMessageLong m_hWndFindText, WM_SYSCOMMAND, SC_CLOSE, 0
   End If
   If Not (m_lptrFindBuff = 0) Then
      LocalUnlock m_hFindBuffMem
      m_lptrFindBuff = 0
   End If
   If Not (m_hFindBuffMem = 0) Then
      LocalFree m_hFindBuffMem
   End If
   If Not (m_lptrReplaceBuff = 0) Then
      LocalUnlock m_hReplaceBuffMem
      m_lptrReplaceBuff = 0
   End If
   If Not (m_hReplaceBuffMem = 0) Then
      LocalFree m_hReplaceBuffMem
      m_hReplaceBuffMem = 0
   End If
End Sub

Private Sub Messages_WMArrival(hwnd As Long, uMsg As Long, wParam As Long, lParam As Long, lRetVal As Long)
Dim tFR As FINDREPLACE
Dim sToFind As String
Dim sReplaceWith As String
Dim Cancel As Boolean
Dim didFind As Boolean
Dim lStart As Long, lEnd As Long
   Select Case uMsg
   Case m_iFindReplaceMsg
      CopyMemory tFR, ByVal lParam, Len(tFR)
      Select Case True
      
      Case ((tFR.flags And FR_DIALOGTERM) = FR_DIALOGTERM)
      'dialog box is terminating
        Messages.Unsubclass
         m_hWndFindText = 0
         RaiseEvent Terminated
      
      Case ((tFR.flags And FR_SHOWHELP) = FR_SHOWHELP)
        RaiseEvent ShowHelp
         
      Case ((tFR.flags And FR_FINDNEXT) = FR_FINDNEXT)
      'Find Next button was pressed
         sToFind = GetTextFromPtr(tFR.lpstrFindWhat)

         didFind = FindNext(sToFind, lStart, tFR.flags)
         RaiseEvent FoundNext(didFind, sToFind, lStart, Cancel)
         If (Not didFind) And (Not Cancel) Then MsgBox "Search Complete."
         SetFocus m_hwndTxt

      Case ((tFR.flags And FR_REPLACE) = FR_REPLACE)
      'Replace Button was pressed
            'is anything selected?
            SendMessage m_hwndTxt, EM_GETSEL, VarPtr(lStart), VarPtr(lEnd)
            If lEnd > lStart Then
                sToFind = GetTextFromPtr(tFR.lpstrFindWhat)
                sReplaceWith = GetTextFromPtr(tFR.lpstrReplaceWith)
                 'this helps with the highlighting
                'lRetVal = Messages.callWindProc(hWnd, uMsg, wParam, lParam)
                RaiseEvent BeforeReplace(sToFind, sReplaceWith, lStart, Cancel)
                'replace selected text
                If Not Cancel Then SendMessageStr m_hwndTxt, EM_REPLACESEL, 1&, sReplaceWith
                'get new text
                gTxtSrc = GetTextfromBox
                If gTxtSrc = "" Then Exit Sub
                'find next occurance
                didFind = FindNext(sToFind, lStart, tFR.flags)
                Cancel = False
                RaiseEvent FoundNext(didFind, sToFind, lStart, Cancel)
                If (Not didFind) And (Not Cancel) Then MsgBox "Search Complete."
            End If
            SetFocus m_hwndTxt

      Case ((tFR.flags And FR_REPLACEALL) = FR_REPLACEALL)
      'Replace All Button was Pressed
         sToFind = GetTextFromPtr(tFR.lpstrFindWhat)
         sReplaceWith = GetTextFromPtr(tFR.lpstrReplaceWith)
         'is anything selected?
         SendMessage m_hwndTxt, EM_GETSEL, VarPtr(lStart), VarPtr(lEnd)
         RaiseEvent BeforeReplaceAll(sToFind, sReplaceWith, Cancel)
         If Not Cancel Then 'allow user to replace all?
             Do While lEnd > lStart
                 'replace selected text
                 SendMessageStr m_hwndTxt, EM_REPLACESEL, 1&, sReplaceWith
                 'get new text
                 gTxtSrc = GetTextfromBox
                 If gTxtSrc = "" Then Exit Do
                 'find next occurance
                 If Not FindNext(sToFind, lStart, tFR.flags) Then Exit Do
                 SendMessage m_hwndTxt, EM_GETSEL, VarPtr(lStart), VarPtr(lEnd)
             Loop
            End If
            SetFocus m_hwndTxt
     End Select
   Case Else
    lRetVal = Messages.callWindProc(hwnd, uMsg, wParam, lParam)
   End Select

End Sub
Private Function FindNext(strFindWhat As String, lStart As Long, eFlags As EFindReplaceFlags) As Boolean

Dim lEnd As Long
Dim sp As Long, ep As Long
Dim char As String * 1
             FindNext = False
             If Len(strFindWhat) = 0 Then Exit Function
                'get current selection position
                SendMessage m_hwndTxt, EM_GETSEL, VarPtr(sp), VarPtr(ep)
                ep = ep + 1
repeat:
                If eFlags And FR_DOWN Then 'search forwards
                    
                    ' Get the MatchCase option
                    If eFlags And FR_MATCHCASE Then
                         lStart = InStr(ep, gTxtSrc, strFindWhat)
                    Else
                         lStart = InStr(ep, LCase(gTxtSrc), LCase(strFindWhat))
                    End If
                    
                    If lStart = 0 Then 'didn't find match start from beginning
                        If ep > 1 Then
                            ep = 1
                            GoTo repeat
                        Else
                            Exit Function
                        End If
                    End If
                    
                
                Else 'search backwards
                    
                    ' Get the MatchCase option
                    If eFlags And FR_MATCHCASE Then
                         lStart = InStrRev(LCase(gTxtSrc), LCase(strFindWhat), sp)
                    Else
                         lStart = InStrRev(gTxtSrc, strFindWhat, sp)
                    End If
                    
                    If lStart = 0 Then 'didn't find match start at end
                        If sp < Len(gTxtSrc) Then
                            sp = Len(gTxtSrc)
                            GoTo repeat
                        Else
                            Exit Function
                        End If
                    End If
                 
                End If
                lEnd = lStart + Len(strFindWhat) - 1
                 
                ' Get the Whole Word option
                If eFlags And FR_WHOLEWORD Then
                'look for word breaks before and after selection
                    If lStart > 1 Then
                        char = Mid(gTxtSrc, lStart - 1, 1)
                        If Not isWordBreak(char) Then lStart = 0
                    End If
                    If lEnd < Len(gTxtSrc) Then
                        char = Mid(gTxtSrc, lEnd + 1, 1)
                        If Not isWordBreak(char) Then lStart = 0
                    End If
                End If

                Call SendMessage(m_hwndTxt, EM_SETSEL, lStart - 1, lEnd)
                SetFocus m_hwndTxt
            FindNext = True
End Function

Private Function isWordBreak(strchar As String) As Boolean
    Select Case strchar
    Case " ", ",", ".", vbCr, vbLf, ":", ";"
        isWordBreak = True
    Case Else
        isWordBreak = False
    End Select
End Function

Private Function GetSelected(strText As String) As String
Dim LENsel As Long
Dim i As Long, j As Long
Dim lStart As Long, lEnd As Long

'prevent crashes when Editbox does not have focus
SetFocus m_hwndTxt
'get what is already selected
SendMessage m_hwndTxt, EM_GETSEL, VarPtr(lStart), VarPtr(lEnd)

LENsel = lEnd - lStart
lStart = lStart + 1
If LENsel = 0 Then
'look for a full word
    i = lStart + 1
    While Not isWordBreak(Mid(strText, i, 1))
        i = i + 1
    Wend
    j = lStart
    Do While Not isWordBreak(Mid(strText, j, 1))
        j = j - 1
        If j = 0 Then Exit Do
    Loop
    GetSelected = Mid(strText, j + 1, i - j - 1)
    'select word in box
    If j = 1 Then j = 0
    SendMessage m_hwndTxt, EM_SETSEL, j, i - 1
    SetFocus m_hwndTxt
Else
    GetSelected = Trim(Mid(strText, lStart, LENsel))
End If

End Function

Public Sub Terminate()
'allows developer to terminate the dialog
    SendMessage m_hWndFindText, WM_CLOSE, 0, 0
End Sub


Public Property Let WholeWord(ByVal vData As frWHOLEWORD)
    mvarWholeWord = vData
End Property

Public Property Get WholeWord() As frWHOLEWORD
    WholeWord = mvarWholeWord
End Property

Public Property Let UpDown(ByVal vData As frUPDOWN)
    mvarUpDown = vData
End Property

Public Property Get UpDown() As frUPDOWN
    UpDown = mvarUpDown
End Property

Public Property Let MatchCase(ByVal vData As frMATCHCASE)
    mvarMatchCase = vData
End Property

Public Property Get MatchCase() As frMATCHCASE
    MatchCase = mvarMatchCase
End Property

Public Property Let ShowHelp(ByVal vData As frSHOWHELP)
    mvarShowHelp = vData
End Property

Public Property Get ShowHelp() As frSHOWHELP
    ShowHelp = mvarShowHelp
End Property

Private Function GetTextfromBox() As String
'get text to search
Dim lLen As Long
Dim strBox As String

    lLen = SendMessage(m_hwndTxt, WM_GETTEXTLENGTH, 0, 0)
    If lLen > 0 Then
        strBox = String(lLen, 0)
        SendMessageStr m_hwndTxt, WM_GETTEXT, lLen, strBox
        GetTextfromBox = strBox
    Else
        GetTextfromBox = ""
    End If
    
End Function

Private Function GetTextFromPtr(ptr As Long) As String
Dim strText As String
strText = Space(lstrlen(ptr))
lstrcpyFromPtr strText, ptr
GetTextFromPtr = strText
End Function
